namespace :mainPage do
  desc "Generate the MainPage"
  task :highlights => :environment do
    repository = Portalmec::Application.repository
    puts 'Generate the main page subject highlights'
    general_highlights = Array.new
    subjects = repository.for(:subject).all
    subjects.each do |subject|
      # select all the learning objects about that subject
      objects = subject.learning_objects
      # transform the objects to RankingItem
      objects = objects.collect do |object|
        Ranking::Item.new(object.id,object.views,object.downloads,object.likes)
      end
      # rank them
      rater = Ranking::Rater.new(Ranking::Strategies::BasicRater.new(0,1,100))
      objects = rater.sortByRate(objects)
      # select the five first objects to the general highlight
      (general_highlights << objects.take(5)).flatten!

      # add the object to the subject highlight
      puts subject.name
      repository.for(:subject).update(subject.id,'set','highlights','[]')
      objects.each do |object|
        repository.for(:subject).update(subject.id,'add','highlights',object.name)
      end
    end
    puts 'Generating the main page highlights'
    mainPage = repository.for(:mainPage).all.first
    rid = mainPage['@rid']
    repository.for(:mainPage).update(rid,'set','highlights','[]')
    general_highlights.each do |general_highlight|
      repository.for(:mainPage).update(rid,'add','highlights',general_highlight.name)
    end
  end
end
